//***************************************************************************
//
//  Copyright  Microsoft Corporation.  All rights reserved.
//
//  FWcommon.h
//
//  Purpose: Definition of EventProvider class
//
//***************************************************************************

// ALWAYS INCLUDE THIS FILE FIRST!

#ifndef INCLUDED_FWCOMMON_H
#define INCLUDED_FWCOMMON_H

#if _MSC_VER > 1000
#pragma once
#endif

#define FRAMEWORK_ALLOW_DEPRECATED 0

// move warnings to level four
#pragma warning(4 : 4275 4800 4786 4251)
//	C4275: non DLL-interface classkey 'identifier' used as base for DLL-interface classkey 'identifier'
//	C4800: forcing bool variable to one or zero, possible performance loss
//	C4786: 'identifier' : identifier was truncated to 'number' characters in the debug information
//	C4251: 'identifier' : class 'type' needs to have dll-interface to export class 'type2'


#ifndef INCLUDED_WINDOWS_H
#include <windows.h>
#endif

// This function gets macro'ed to GetObjectW and GetObjectA based on the
// contents of UNICODE.  However, we USE a function called GetObject.  For
// single binary support, we can't have this being macro'ed.  If the actual
// win32 api GetObject is needed, call the GetObjectW or GetObjectA directly.
#undef GetObject
#ifndef INCLUDED_WBEMIDL_H
#include <wbemidl.h>
#endif
#ifndef INCLUDED_WMIUTILS_H
#include <wmiutils.h>
#endif

// If USE_POLARITY not defined, some Framedyn.dll symbols may not resolve correctly
// It's a declspec(dllimport/dllexport) issue.
#ifndef USE_POLARITY

// For most users, this is the correct setting for POLARITY.
#define USE_POLARITY

#endif

// Required since TCHAR.H defines _ttoi64 -> atoi64, which requires oldnames.lib, which
// we don't use.
#define atoi64 _atoi64

#ifndef INCLUDED_POLARITY_H
#include <polarity.h>
#endif

#ifndef EXPORT_LOCKIT

#undef _CRTIMP
#define _CRTIMP
#ifndef INCLUDED_YVALS_H
#include <yvals.h>
#endif
#undef _CRTIMP

#else

#undef _CRTIMP
#define _CRTIMP POLARITY
#ifndef INCLUDED_YVALS_H
#include <yvals.h>
#endif
#undef _CRTIMP

#endif

#ifndef INCLUDED_STLLOCK_H
#include <stllock.h>
#endif
extern POLARITY CCritSec g_cs;

#ifndef INCLUDED_UTILLIB_H
#include <utillib.h>
#endif
#ifndef INCLUDED_THRDBASE_H
#include <thrdbase.h>
#endif
#ifndef INCLUDED_REFPTRCO_H
#include <refptrco.h>
#endif
#ifndef INCLUDED_METHODCO_H
#include <methodco.h>
#endif
#ifndef INCLUDED_FRQUERY_H
#include <frquery.h>
#endif
#ifndef INCLUDED_WBEMGLUE_H
#include <wbemglue.h>
#endif
#ifndef INCLUDED_INSTANCE_H
#include <instance.h>
#endif

class CFramework_Exception
{
private:

	CHString m_sErrorText;
    HRESULT m_hr;

public:

	CFramework_Exception ( LPCWSTR lpwszErrorText, HRESULT hr) : m_hr ( hr ) , m_sErrorText ( lpwszErrorText) {}
	CFramework_Exception ( LPCWSTR lpwszErrorText) : m_hr ( WBEM_S_NO_ERROR ) , m_sErrorText ( lpwszErrorText) {}
	~CFramework_Exception () {}

	HRESULT GetHRESULT() { return m_hr ; }
	CHString &GetErrorText() { return m_sErrorText; }
};

#endif
