
/*++ BUILD Version: 0001    Increment this if a change has global effects

Copyright (c) Microsoft Corporation. All rights reserved.

Module Name:


    windows.h

Abstract:

    Master include file for Windows applications.

--*/

#ifndef INCLUDED_WINDOWS_H
#define INCLUDED_WINDOWS_H

#ifndef INCLUDED_BASETSD_H
#include <basetsd.h>
#endif

#if defined (_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/*  If defined, the following flags inhibit definition
 *     of the indicated items.
 *
 *  NOGDICAPMASKS     - CC_*, LC_*, PC_*, CP_*, TC_*, RC_
 *  NOVIRTUALKEYCODES - VK_*
 *  NOWINMESSAGES     - WM_*, EM_*, LB_*, CB_*
 *  NOWINSTYLES       - WS_*, CS_*, ES_*, LBS_*, SBS_*, CBS_*
 *  NOSYSMETRICS      - SM_*
 *  NOMENUS           - MF_*
 *  NOICONS           - IDI_*
 *  NOKEYSTATES       - MK_*
 *  NOSYSCOMMANDS     - SC_*
 *  NORASTEROPS       - Binary and Tertiary raster ops
 *  NOSHOWWINDOW      - SW_*
 *  OEMRESOURCE       - OEM Resource values
 *  NOATOM            - Atom Manager routines
 *  NOCLIPBOARD       - Clipboard routines
 *  NOCOLOR           - Screen colors
 *  NOCTLMGR          - Control and Dialog routines
 *  NODRAWTEXT        - DrawText() and DT_*
 *  NOGDI             - All GDI defines and routines
 *  NOKERNEL          - All KERNEL defines and routines
 *  NOUSER            - All USER defines and routines
 *  NONLS             - All NLS defines and routines
 *  NOMB              - MB_* and MessageBox()
 *  NOMEMMGR          - GMEM_*, LMEM_*, GHND, LHND, associated routines
 *  NOMETAFILE        - typedef METAFILEPICT
 *  NOMINMAX          - Macros min(a,b) and max(a,b)
 *  NOMSG             - typedef MSG and associated routines
 *  NOOPENFILE        - OpenFile(), OemToAnsi, AnsiToOem, and OF_*
 *  NOSCROLL          - SB_* and scrolling routines
 *  NOSERVICE         - All Service Controller routines, SERVICE_ equates, etc.
 *  NOSOUND           - Sound driver routines
 *  NOTEXTMETRIC      - typedef TEXTMETRIC and associated routines
 *  NOWH              - SetWindowsHook and WH_*
 *  NOWINOFFSETS      - GWL_*, GCL_*, associated routines
 *  NOCOMM            - COMM driver routines
 *  NOKANJI           - Kanji support stuff.
 *  NOHELP            - Help engine interface.
 *  NOPROFILER        - Profiler interface.
 *  NODEFERWINDOWPOS  - DeferWindowPos routines
 *  NOMCX             - Modem Configuration Extensions
 */

#if defined(RC_INVOKED) && !defined(NOWINRES)

#ifndef INCLUDED_WINRESRC_H
#include <winresrc.h>
#endif

#else

#if defined(RC_INVOKED)
/* Turn off a bunch of stuff to ensure that RC files compile OK. */
#define NOATOM
#define NOGDI
#define NOGDICAPMASKS
#define NOMETAFILE
#define NOMINMAX
#define NOMSG
#define NOOPENFILE
#define NORASTEROPS
#define NOSCROLL
#define NOSOUND
#define NOSYSMETRICS
#define NOTEXTMETRIC
#define NOWH
#define NOCOMM
#define NOKANJI
#define NOCRYPT
#define NOMCX
#endif

#if defined (_MSC_VER)
#if ( _MSC_VER >= 800 )
#ifndef __cplusplus
#pragma warning(disable:4116)		// TYPE_ALIGNMENT generates this - move it
#endif								// outside the warning push/pop scope.
#endif
#endif

#ifndef RC_INVOKED
#if     ( _MSC_VER >= 800 )
#pragma warning(disable:4514)
#ifndef __WINDOWS_DONT_DISABLE_PRAGMA_PACK_WARNING__
#pragma warning(disable:4103)
#endif
#if _MSC_VER >= 1200
#pragma warning(push)
#endif
#pragma warning(disable:4001)
#pragma warning(disable:4201)
#pragma warning(disable:4214)
#endif
#ifndef INCLUDED_EXCPT_H
#include <excpt.h>
#endif
#ifndef INCLUDED_STDARG_H
#include <stdarg.h>
#endif
#endif /* RC_INVOKED */

#ifndef INCLUDED_WINDEF_H
#include <windef.h>
#endif
#ifndef INCLUDED_WINBASE_H
#include <winbase.h>
#endif
#ifndef INCLUDED_WINGDI_H
#include <wingdi.h>
#endif
#ifndef INCLUDED_WINUSER_H
#include <winuser.h>
#endif
#if !defined(_MAC) || defined(_WIN32NLS)
#ifndef INCLUDED_WINNLS_H
#include <winnls.h>
#endif
#endif
#ifndef _MAC
#ifndef INCLUDED_WINCON_H
#include <wincon.h>
#endif
#ifndef INCLUDED_WINVER_H
#include <winver.h>
#endif
#endif
#if !defined(_MAC) || defined(_WIN32REG)
#ifndef INCLUDED_WINREG_H
#include <winreg.h>
#endif
#endif
#ifndef _MAC
#ifndef INCLUDED_WINNETWK_H
#include <winnetwk.h>
#endif
#endif

#ifndef WIN32_LEAN_AND_MEAN
#ifndef INCLUDED_CDERR_H
#include <cderr.h>
#endif
#ifndef INCLUDED_DDE_H
#include <dde.h>
#endif
#ifndef INCLUDED_DDEML_H
#include <ddeml.h>
#endif
#ifndef INCLUDED_DLGS_H
#include <dlgs.h>
#endif
#ifndef _MAC
#ifndef INCLUDED_LZEXPAND_H
#include <lzexpand.h>
#endif
#ifndef INCLUDED_MMSYSTEM_H
#include <mmsystem.h>
#endif
#ifndef INCLUDED_NB30_H
#include <nb30.h>
#endif
#ifndef INCLUDED_RPC_H
#include <rpc.h>
#endif
#endif
#ifndef INCLUDED_SHELLAPI_H
#include <shellapi.h>
#endif
#ifndef _MAC
#ifndef INCLUDED_WINPERF_H
#include <winperf.h>
#endif
#ifndef INCLUDED_WINSOCK_H
#include <winsock.h>
#endif
#endif
#ifndef NOCRYPT
#ifndef INCLUDED_WINCRYPT_H
#include <wincrypt.h>
#endif
#ifndef INCLUDED_WINEFS_H
#include <winefs.h>
#endif
#ifndef INCLUDED_WINSCARD_H
#include <winscard.h>
#endif
#endif

#ifndef NOGDI
#ifndef _MAC
#ifndef INCLUDED_WINSPOOL_H
#include <winspool.h>
#endif
#ifdef INC_OLE1
#ifndef INCLUDED_OLE_H
#include <ole.h>
#endif
#else
#ifndef INCLUDED_WINNT_H
#include <winnt.h>
#endif
#ifndef INCLUDED_OLE2_H
#include <ole2.h>
#endif
#endif /* !INC_OLE1 */
#endif /* !MAC */
#ifndef INCLUDED_COMMDLG_H
#include <commdlg.h>
#endif
#endif /* !NOGDI */
#endif /* WIN32_LEAN_AND_MEAN */

#ifndef INCLUDED_STRALIGN_H
#include <stralign.h>
#endif

#ifdef _MAC
#ifndef INCLUDED_WINWLM_H
#include <winwlm.h>
#endif
#endif


#ifdef INC_OLE2
#ifndef INCLUDED_OLE2_H
#include <ole2.h>
#endif
#endif /* INC_OLE2 */

#ifndef _MAC
#ifndef NOSERVICE
#ifndef INCLUDED_WINSVC_H
#include <winsvc.h>
#endif
#endif

#if(WINVER >= 0x0400)
#ifndef NOMCX
#ifndef INCLUDED_MCX_H
#include <mcx.h>
#endif
#endif /* NOMCX */

#ifndef NOIME
#ifndef INCLUDED_IMM_H
#include <imm.h>
#endif
#endif
#endif /* WINVER >= 0x0400 */
#endif

#ifndef RC_INVOKED
#if     ( _MSC_VER >= 800 )
#if _MSC_VER >= 1200
#pragma warning(pop)
#else
#pragma warning(default:4001)
#pragma warning(default:4201)
#pragma warning(default:4214)
/* Leave 4514 disabled.  It's an unneeded warning anyway. */
#endif
#endif
#endif /* RC_INVOKED */

#endif /* RC_INVOKED */

#endif

